Affected QGIS version:master Regression?: No
Pull Request or Patch supplied:No Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 23717

Description

Further testing of aggregated’s @parent feature led to the discovery of another oddity, whereas a filtered aggregation with the following

expression: (intersects($geometry,geometry(@parent))) will not work reliably, with results varying either based on the number of features

drawn.

Steps to reproduce

    1. Open the test confused.qgs project (download it here: http://www.licadho-cambodia.org/confused.zip)

    2. Right click on ‘testing’ layer, and select “zoom to layer”

    3. Let it render, and count the number of red polygons in the cluster of polygons to the right (here, it’s 4 – see wrong screenshot below)

    4. Pan the canvas to totally hide the cluster of polygons to the left

    5. Let it render, and count the number of red polygons (here, it’s 3 – see correct screenshot below)

I have no idea why the aggregation expression gets confused and give two different result (one clearly wrong). This should be addressed

so this feature can be relied upon with fear of wrong results :)

Screenshots

Wrong:

http://i.imgur.com/jhrmRI6.png

Correct:

http://i.imgur.com/2zSKHYi.png

Associated revisions

Revision c19fb1ca - 2017-09-18 04:06 PM - Mathieu Pellerin - nIRV

[expression] fix caching for aggregate() and @parent exp. (fixes #15797)

History

#1 - 2017-03-07 03:29 AM - Giovanni Manghi

- Priority changed from High to Normal

#2 - 2017-05-01 01:02 AM - Giovanni Manghi

- Easy fix? set to No

- Regression? set to No

#3 - 2017-09-18 11:50 AM - Harrissou Santanna

- Description updated
http://www.licadho-cambodia.org/confused.zip


@Matthieu. Is it the same issue than #16481?

#4 - 2017-09-18 11:52 AM - Mathieu Pellerin - nIRV

Harrissou, I suspect it is indeed.

#5 - 2017-09-18 04:05 PM - Mathieu Pellerin - nIRV

- % Done changed from 0 to 100

- Status changed from Open to Closed

Applied in changeset commit:qgis|c19fb1ca0ca03e7f04734af038aefc8b18834065.
